/********************************** (C) COPYRIGHT *******************************
* File Name          : usb_endp.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : Endpoint routines
*******************************************************************************/ 
#include "usb_lib.h"
#include "usb_desc.h"
#include "usb_mem.h"
#include "hw_config.h"
#include "usb_istr.h"
#include "usb_pwr.h"
#include "stdio.h"
/* Interval between sending IN packets in frame number (1 frame = 1ms) */
#define IN_FRAME_INTERVAL             5

/* Private variables */
uint8_t USB_Rx_Buffer[USBD_DATA_SIZE];
u16 USB_Rx_Cnt=0; 
u8 up_flag = 0;


//volatile UINT32 rec_cnt = 0;
//volatile UINT32 tx_cnt = 0;
//UINT16 state = 0;
//uint16_t hjk;
/*******************************************************************************
* Function Name  : EP2_IN_Callback
* Description    : Endpoint 2 IN.
* Input          : None.
* Return         : None.
*******************************************************************************/
void EP1_IN_Callback (void)
{ 
//	uint16_t i;
//	i = (rec_cnt-tx_cnt)>64 ? 64 : (rec_cnt-tx_cnt);
//	state = _GetEPTxStatus(ENDP1);
//	if(i!=0) {tx_cnt += i; /*Delay_Us(200);*/UserToPMABufferCopy(USB_Rx_Buffer, ENDP1_TXADDR, i);SetEPTxCount(ENDP1, i); SetEPTxValid(ENDP1);}
//	if(state != 0x20) printf("=%x\n", state);
//	if(i!=64){/*printf("**%d %ld %ld\n",i, rec_cnt, tx_cnt);*/ rec_cnt = 0;	tx_cnt = 0;}
}

/*******************************************************************************
* Function Name  : EP2_OUT_Callback
* Description    : Endpoint 2 IN.
* Input          : None.
* Return         : None.
*******************************************************************************/
void EP3_OUT_Callback(void)
{
//	uint16_t j; 
	#if 1  //ش
//	j = USB_SIL_Read(EP3_OUT, USB_Rx_Buffer);
//	if( rec_cnt==0 ){ SetEPTxCount(ENDP1, 0); SetEPTxValid(ENDP1); }
//	rec_cnt += j;
////    UserToPMABufferCopy(USB_Rx_Buffer, ENDP1_TXADDR, i);
////	state = _GetEPTxStatus(ENDP1);
////	if(state == 0x20) {tx_cnt += i;SetEPTxCount(ENDP1, i);SetEPTxValid(ENDP1);}
////	if(state!=0X20) printf("TS:%02x\n",state);
////	state = _GetEPRxStatus(ENDP1);
////	printf("Rx_state:%02x\n",state);
//	SetEPRxValid(ENDP3);
//	up_flag = 1;
		
	#endif
	#if 0  //´
	SetEPRxValid(ENDP3);
	#endif
	#if 0 //ϴ
	up_flag = 1;
	SetEPTxCount(ENDP1, 64);
	SetEPTxValid(ENDP1);
	SetEPRxValid(ENDP3);
	#endif
}

/*******************************************************************************
* Function Name  : SOF_Callback
* Description    : SOF call back.
* Input          : None.
* Return         : None.
*******************************************************************************/
void SOF_Callback(void)
{
	static uint32_t FrameCount = 0;

	if(bDeviceState == CONFIGURED)
	{
		if (FrameCount++ == IN_FRAME_INTERVAL)
		{		
			FrameCount = 0;
			//Handle_USBAsynchXfer();	
		}
	}  
}






