/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2019/10/15
* Description        : Main program body.
*******************************************************************************/ 
#include "debug.h"
#include "usb_lib.h"
#include "hw_config.h"
#include "usb_pwr.h"

/* Global define */


/* Global Variable */    
/*

	CDCشע
	1CDC豸һϴ64ֽʱڵǲʾ64ֽڵģҪһ0ȰΪѾ
	2ÿϴһʱҪж϶˵ϴ־жǷNAKٽһϴȷһINĴ(CTR_TX=1)ӲԶôλΪNAK״̬
	3óʱƣһϴʱʱϴ0ϴ֪ڵǰݴ䡣
	һǡ64ֽڣ֪滹ûݣܻȰݴԼĻУշݳȲƥļ
*/

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
volatile UINT32 rec_cnt = 0;
volatile UINT32 tx_cnt = 0;
volatile UINT32 timeout = 0;

UINT16 state = 0;
uint16_t hjk;
extern uint8_t USB_Rx_Buffer[];

int main(void)
{   
	u16 t, i, j, state;
	u16 len;	
	u16 times=0;    
	u8 usbstatus=0;		
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	Delay_Init(); 
	USART_Printf_Init(115200); 
	printf("Start @Chip_ID:%08x\r\n", DBGMCU->IDCODE );
	 
	printf("USBD Device Test\r\n");
	Set_USBConfig(); 
    USB_Init();	    
   
	USB_Port_Set(DISABLE, DISABLE);	
	Delay_Ms(700);
	USB_Port_Set(ENABLE, ENABLE);
 	USB_Interrupts_Config();    
 	
    
	while(1)
	{
		if(usbstatus!=bDeviceState)
		{
			usbstatus=bDeviceState;
			
			if(usbstatus==CONFIGURED)
			{
				printf("USB Connected\r\n");				
			}else
			{
				printf("USB disConnected\r\n");				
			}
		}
		
		state = _GetEPRxStatus(ENDP3);
		if( state != 0x3000 ){
			j = USB_SIL_Read(EP3_OUT, USB_Rx_Buffer);
//			if( rec_cnt==0 ){ SetEPTxCount(ENDP1, 0); SetEPTxValid(ENDP1); }
			rec_cnt += j;
			SetEPRxValid(ENDP3);
			timeout = 0;
		}
		
		state = _GetEPTxStatus(ENDP1);
		if( state != 0x30 ){
			i = (rec_cnt-tx_cnt)>64 ? 64 : (rec_cnt-tx_cnt);
			if(i!=0) {tx_cnt += i; UserToPMABufferCopy(USB_Rx_Buffer, ENDP1_TXADDR, i);SetEPTxCount(ENDP1, i); SetEPTxValid(ENDP1);timeout = 0;}
//			else if(rec_cnt>80000) {rec_cnt = 0;	tx_cnt = 0;}
//			if(i!=64){/*printf("**%d %ld %ld\n",i, rec_cnt, tx_cnt);*/ rec_cnt = 0;	tx_cnt = 0;}
		}
		timeout++;
		if( timeout > 0x8ffff ){
			timeout = 0;
			printf("**%d %ld %ld\n",i, rec_cnt, tx_cnt);
			state = _GetEPTxStatus(ENDP1);
			if( state != 0x30 ){
				SetEPTxCount(ENDP1, 0); SetEPTxValid(ENDP1);
			}
			rec_cnt = 0;	tx_cnt = 0;
		}
	}
}







